import os
import shutil
import sys

from mykit.kit.utils import printer, print_screen

from ..constants import TEMPLATE_DIR_PTH
from .workflows_writer import workflows_writer
from .settings_writer import settings_writer


def inspect(docs, workflows):
    
    ## docs/
    if os.path.isdir(docs):
        printer(f"ERROR: 'docs/' folder already exists.")
        sys.exit(1)
    
    ## workflows
    if os.path.isfile(workflows):
        printer(f"ERROR: 'rebuild-docs.yml' file already exists.")
        sys.exit(1)


def run():

    CWD = os.getcwd()

    WORKFLOWS = os.path.join(CWD, '.github', 'workflows', 'rebuild-docs.yml')
    DOCS = os.path.join(CWD, 'docs')
    SETTINGS = os.path.join(CWD, 'docs', 'settings.txt')

    inspect(DOCS, WORKFLOWS)

    print_screen(
        'Welcome to NICS!\n\n'
    )

    author = input('Enter your name: ')
    email = input('Enter your email: ')
    gh_username = input('Enter your GitHub username: ')
    gh_repo = input('Enter this GitHub repository name: ')
    main_branch_name = input("Your main branch name (e.g. 'master'): ")

    ## if the dirs don't exist
    if not os.path.isdir( os.path.join(CWD, '.github') ):
        os.mkdir( os.path.join(CWD, '.github') )
        printer(f"INFO: Dir {repr( os.path.join(CWD, '.github') )} is created.")
    if not os.path.isdir( os.path.join(CWD, '.github', 'workflows') ):
        os.mkdir( os.path.join(CWD, '.github', 'workflows') )
        printer(f"INFO: Dir {repr( os.path.join(CWD, '.github', 'workflows') )} is created.")

    workflows_writer(WORKFLOWS, author, email, gh_repo, main_branch_name)
    
    printer(f"INFO: Copying 'docs/' folder.")
    shutil.copytree( os.path.join(TEMPLATE_DIR_PTH, 'docs'), DOCS )
    printer(f'INFO: Done, {repr(DOCS)} is created.')

    settings_writer(SETTINGS, author, gh_username, gh_repo)

    print_screen(
        'Everything is done, now follow these last steps:\n'
        '1. foo\n'
        '2. \n'
    )